Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -4210,343 +4404,307 @@
     zksa   = 0.0_wp
     zkocnv = 0.0_wp
-    
+
     SELECT CASE ( nsnucl )
-    
-    CASE(1)   ! Binary H2SO4-H2O nucleation
-       
-       zc_h2so4 = pcsa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-       CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit,  zksa, &
-                     zkocnv )      
-    
-    CASE(2)   ! Activation type nucleation
-    
-       zc_h2so4 = pcsa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-       CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa,  znoc, zdcrit, zksa,  &
-                     zkocnv )
-       CALL actnucl( pcsa, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv, act_coeff )
-    
-    CASE(3)   ! Kinetically limited nucleation of (NH4)HSO4 clusters
-       
-       zc_h2so4 = pcsa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-       CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa,    &
-                     zkocnv )
-
-       CALL kinnucl( zc_h2so4, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
-    
-    CASE(4)   ! Ternary H2SO4-H2O-NH3 nucleation
-    
-       zmixnh3 = pcnh3 * ptemp * argas / ( ppres * avo )
-       zc_h2so4 = pcsa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-       CALL ternucl( zc_h2so4, zmixnh3, ptemp, prh, zjnuc, znsa, znoc, zdcrit, &
-                     zksa, zkocnv ) 
-    
-    CASE(5)   ! Organic nucleation, J~[ORG] or J~[ORG]**2
-    
-       zc_org = pcocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
-       zc_h2so4 = pcsa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-       CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa,    &
-                     zkocnv )  
-       CALL orgnucl( pcocnv, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
-    
-    CASE(6)   ! Sum of H2SO4 and organic activation type nucleation, 
-              ! J~[H2SO4]+[ORG]
-       
-       zc_h2so4 = pcsa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-       CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa,    &
-                     zkocnv )  
-       CALL sumnucl( pcsa, pcocnv, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
-
-            
-    CASE(7)   ! Heteromolecular nucleation, J~[H2SO4]*[ORG]
-       
-       zc_h2so4 = pcsa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-       zc_org = pcocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
-       CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa,    &
-                     zkocnv )  
-       CALL hetnucl( zc_h2so4, zc_org, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
-    
-    CASE(8)   ! Homomolecular nucleation of H2SO4 and heteromolecular 
-              ! nucleation of H2SO4 and organic vapour, 
-              ! J~[H2SO4]**2 + [H2SO4]*[ORG] (EUCAARI project)
-       zc_h2so4 = pcsa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-       zc_org = pcocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
-       CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa,    &
-                     zkocnv )  
-       CALL SAnucl( zc_h2so4, zc_org, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
-    
-    CASE(9)   ! Homomolecular nucleation of H2SO4 and organic vapour and
-              ! heteromolecular nucleation of H2SO4 and organic vapour,
-              ! J~[H2SO4]**2 + [H2SO4]*[ORG]+[ORG]**2 (EUCAARI project)
-    
-       zc_h2so4 = pcsa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
-       zc_org = pcocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
-       CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa,    &
-                     zkocnv )  
-
-       CALL SAORGnucl( zc_h2so4, zc_org, zjnuc, zdcrit, znsa, znoc, zksa,      &
-                       zkocnv )
+!
+!--    Binary H2SO4-H2O nucleation
+       CASE(1)
+
+          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
+          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit,  zksa, zkocnv )
+!
+!--    Activation type nucleation
+       CASE(2)
+
+          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
+          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa,  znoc, zdcrit, zksa, zkocnv )
+          CALL actnucl( pc_sa, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv, act_coeff )
+!
+!--    Kinetically limited nucleation of (NH4)HSO4 clusters
+       CASE(3)
+
+          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
+          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
+          CALL kinnucl( zc_h2so4, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+!
+!--    Ternary H2SO4-H2O-NH3 nucleation
+       CASE(4)
+
+          zmixnh3 = pc_nh3 * ptemp * argas / ( ppres * avo )
+          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
+          CALL ternucl( zc_h2so4, zmixnh3, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
+!
+!--    Organic nucleation, J~[ORG] or J~[ORG]**2
+       CASE(5)
+
+          zc_org = pc_ocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
+          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
+          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
+          CALL orgnucl( pc_ocnv, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+!
+!--    Sum of H2SO4 and organic activation type nucleation, J~[H2SO4]+[ORG]
+       CASE(6)
+
+          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
+          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
+          CALL sumnucl( pc_sa, pc_ocnv, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+!
+!--    Heteromolecular nucleation, J~[H2SO4]*[ORG]
+       CASE(7)
+
+          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
+          zc_org = pc_ocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
+          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
+          CALL hetnucl( zc_h2so4, zc_org, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+!
+!--    Homomolecular nucleation of H2SO4 and heteromolecular nucleation of H2SO4 and organic vapour,
+!--    J~[H2SO4]**2 + [H2SO4]*[ORG] (EUCAARI project)
+       CASE(8)
+          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
+          zc_org = pc_ocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
+          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
+          CALL SAnucl( zc_h2so4, zc_org, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+!
+!--    Homomolecular nucleation of H2SO4 and organic vapour and heteromolecular nucleation of H2SO4
+!--    and organic vapour, J~[H2SO4]**2 + [H2SO4]*[ORG]+[ORG]**2 (EUCAARI project)
+       CASE(9)
+
+          zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
+          zc_org = pc_ocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
+          CALL binnucl( zc_h2so4, ptemp, prh, zjnuc, znsa, znoc, zdcrit, zksa, zkocnv )
+          CALL SAORGnucl( zc_h2so4, zc_org, zjnuc, zdcrit, znsa, znoc, zksa, zkocnv )
+
     END SELECT
-    
-    zcsa_local = pcsa
-    zcocnv_local = pcocnv
+
+    zcsa_local = pc_sa
+    zcocnv_local = pc_ocnv
 !
 !-- 2) Change of particle and gas concentrations due to nucleation
-!          
-!-- 2.1) Check that there is enough H2SO4 and organic vapour to produce the
-!--      nucleation  
+!
+!-- 2.1) Check that there is enough H2SO4 and organic vapour to produce the nucleation
     IF ( nsnucl <= 4 )  THEN 
-!--    If the chosen nucleation scheme is 1-4, nucleation occurs only due to 
-!--    H2SO4. All of the total vapour concentration that is taking part to the
-!--    nucleation is there for sulphuric acid (sa = H2SO4) and non-volatile 
-!--    organic vapour is zero.
-       pxsa   = 1.0_wp   ! ratio of sulphuric acid in 3nm particles 
+!
+!--    If the chosen nucleation scheme is 1-4, nucleation occurs only due to H2SO4. All of the total
+!--    vapour concentration that is taking part to the nucleation is there for sulphuric acid
+!--    (sa = H2SO4) and non-volatile organic vapour is zero.
+       pxsa   = 1.0_wp   ! ratio of sulphuric acid in 3nm particles
        pxocnv = 0.0_wp   ! ratio of non-volatile origanic vapour
                                 ! in 3nm particles
     ELSEIF ( nsnucl > 4 )  THEN
-!--    If the chosen nucleation scheme is 5-9, nucleation occurs due to organic
-!--    vapour or the combination of organic vapour and H2SO4. The number of 
-!--    needed molecules depends on the chosen nucleation type and it has an 
-!--    effect also on the minimum ratio of the molecules present. 
-       IF ( pcsa * znsa + pcocnv * znoc < 1.E-14_wp )  THEN
+!
+!--    If the chosen nucleation scheme is 5-9, nucleation occurs due to organic vapour or the
+!--    combination of organic vapour and H2SO4. The number of needed molecules depends on the chosen
+!--    nucleation type and it has an effect also on the minimum ratio of the molecules present.
+       IF ( pc_sa * znsa + pc_ocnv * znoc < 1.E-14_wp )  THEN
           pxsa   = 0.0_wp
-          pxocnv = 0.0_wp             
+          pxocnv = 0.0_wp
        ELSE
-          pxsa   = pcsa * znsa / ( pcsa * znsa + pcocnv * znoc ) 
-          pxocnv = pcocnv * znoc / ( pcsa * znsa + pcocnv * znoc )
-       ENDIF  
+          pxsa   = pc_sa * znsa / ( pc_sa * znsa + pc_ocnv * znoc ) 
+          pxocnv = pc_ocnv * znoc / ( pc_sa * znsa + pc_ocnv * znoc )
+       ENDIF
     ENDIF
-!    
-!-- The change in total vapour concentration is the sum of the concentrations
-!-- of the vapours taking part to the nucleation (depends on the chosen 
-!-- nucleation scheme)
-    zdelta_vap = MIN( zjnuc * ( znoc + znsa ), ( pcocnv * zkocnv + pcsa *      &
-                      zksa ) / ptstep ) 
-!                      
-!-- Nucleation rate J at ~1nm (#/m3s)                           
+!
+!-- The change in total vapour concentration is the sum of the concentrations of the vapours taking
+!-- part to the nucleation (depends on the chosen nucleation scheme)
+    zdelta_vap = MIN( zjnuc * ( znoc + znsa ), ( pc_ocnv * zkocnv + pc_sa * zksa ) / ptstep )
+!
+!-- Nucleation rate J at ~1nm (#/m3s)
     zjnuc = zdelta_vap / ( znoc + znsa )
-!    
-!-- H2SO4 concentration after nucleation in #/m3            
-    zcsa_local = MAX( 1.0_wp, pcsa - zdelta_vap * pxsa ) 
-!    
+!
+!-- H2SO4 concentration after nucleation (#/m3)
+    zcsa_local = MAX( 1.0_wp, pc_sa - zdelta_vap * pxsa )
+!
 !-- Non-volative organic vapour concentration after nucleation (#/m3)
-    zcocnv_local = MAX( 1.0_wp, pcocnv - zdelta_vap * pxocnv )
+    zcocnv_local = MAX( 1.0_wp, pc_ocnv - zdelta_vap * pxocnv )
 !
 !-- 2.2) Formation rate of 3 nm particles (Kerminen & Kulmala, 2002)
 !
-!-- 2.2.1) Growth rate of clusters formed by H2SO4
-!
-!-- GR = 3.0e-15 / dens_clus * sum( molecspeed * molarmass * conc )
-!  
-!-- dens_clus  = density of the clusters (here 1830 kg/m3) 
-!-- molarmass  = molar mass of condensing species (here 98.08 g/mol)
-!-- conc       = concentration of condensing species [#/m3]
-!-- molecspeed = molecular speed of condensing species [m/s]
-!--            = sqrt( 8.0 * R * ptemp / ( pi * molarmass ) )
-!-- (Seinfeld & Pandis, 1998)
-!
-!-- Growth rate by H2SO4 and organic vapour in nm/h (Eq. 21)
-    zGRclust = 2.3623E-15_wp * SQRT( ptemp ) * ( zcsa_local + zcocnv_local )
-!    
+!-- Growth rate by H2SO4 and organic vapour (nm/h, Eq. 21)
+    z_gr_clust = 2.3623E-15_wp * SQRT( ptemp ) * ( zcsa_local + zcocnv_local )
+!
 !-- 2.2.2) Condensational sink of pre-existing particle population
 !
 !-- Diffusion coefficient (m2/s)
-    zdfvap = 5.1111E-10_wp * ptemp ** 1.75_wp * ( p_0 + 1325.0_wp ) / ppres
-!-- Mean free path of condensing vapour (m) (Jacobson (2005), Eq. 15.25 and 
-!-- 16.29)
+    zdfvap = 5.1111E-10_wp * ptemp**1.75_wp * ( p_0 + 1325.0_wp ) / ppres
+!
+!-- Mean free path of condensing vapour (m) (Jacobson (2005), Eq. 15.25 and 16.29)
     zmfp = 3.0_wp * zdfvap * SQRT( pi * amh2so4 / ( 8.0_wp * argas * ptemp ) )
-!-- Knudsen number            
-    zknud = 2.0_wp * zmfp / ( paero(:)%dwet + d_sa )                     
-!-- Transitional regime correction factor (zbeta) according to Fuchs and 
-!-- Sutugin (1971), In: Hidy et al. (ed.), Topics in current  aerosol research,
-!-- Pergamon. (Eq. 4 in Kerminen and Kulmala, 2002)
-    zbeta = ( zknud + 1.0_wp) / ( 0.377_wp * zknud + 1.0_wp + 4.0_wp /         &
-            ( 3.0_wp * massacc ) * ( zknud + zknud ** 2 ) )  
-!-- Condensational sink (#/m2) (Eq. 3)
+!
+!-- Knudsen number
+    zknud = 2.0_wp * zmfp / ( paero(:)%dwet + d_sa )
+!
+!-- Transitional regime correction factor (zbeta) according to Fuchs and Sutugin (1971) (Eq. 4 in
+!-- Kerminen and Kulmala, 2002)
+    zbeta = ( zknud + 1.0_wp) / ( 0.377_wp * zknud + 1.0_wp + 4.0_wp / ( 3.0_wp * massacc ) *      &
+            ( zknud + zknud**2 ) )
+!
+!-- Condensational sink (#/m2, Eq. 3)
     zcsink = SUM( paero(:)%dwet * zbeta * paero(:)%numc )
 !
-!-- Parameterised formation rate of detectable 3 nm particles (i.e. J3)
+!-- 2.2.3) Parameterised formation rate of detectable 3 nm particles (i.e. J3)
     IF ( nj3 == 1 )  THEN   ! Kerminen and Kulmala (2002)
-!--    2.2.3) Parameterised formation rate of detectable 3 nm particles
-!--    Constants needed for the parameterisation:
-!--    dapp = 3 nm and dens_nuc = 1830 kg/m3
-       IF ( zcsink < 1.0E-30_wp )  THEN 
+!
+!--    Constants needed for the parameterisation: dapp = 3 nm and dens_nuc = 1830 kg/m3
+       IF ( zcsink < 1.0E-30_wp )  THEN
           zeta = 0._dp
        ELSE
+!
 !--       Mean diameter of backgroud population (nm)
-          zdmean = 1.0_wp / SUM( paero(:)%numc ) * SUM( paero(:)%numc *        &
-                   paero(:)%dwet ) * 1.0E+9_wp
+          zdmean = 1.0_wp / SUM( paero(:)%numc ) * SUM( paero(:)%numc * paero(:)%dwet ) * 1.0E+9_wp
+!
 !--       Proportionality factor (nm2*m2/h) (Eq. 22)
-          zgamma = 0.23_wp * ( zdcrit * 1.0E+9_wp ) ** 0.2_wp * ( zdmean /     &
-                 150.0_wp ) ** 0.048_wp * ( ptemp / 293.0_wp ) ** ( -0.75_wp ) &
-                 * ( arhoh2so4 / 1000.0_wp ) ** ( -0.33_wp )
-!--       Factor eta (nm) (Eq. 11)
-          zeta = MIN( zgamma * zcsink / zGRclust, zdcrit * 1.0E11_wp ) 
-       ENDIF
-!       
-!--    Number conc. of clusters surviving to 3 nm in a time step (#/m3) (Eq.14)
-       zj3 = zjnuc * EXP( MIN( 0.0_wp, zeta / 3.0_wp - zeta /                  &
-                               ( zdcrit * 1.0E9_wp ) ) )                    
-
-    ELSEIF ( nj3 > 1 )  THEN
-!--    Defining the value for zm_para. The growth is investigated between
-!--    [d1,reglim(1)] = [zdcrit,3nm]    
-!--    m = LOG( CoagS_dx / CoagX_zdcrit ) / LOG( reglim / zdcrit ) 
-!--    (Lehtinen et al. 2007, Eq. 5)
-!--    The steps for the coagulation sink for reglim = 3nm and zdcrit ~= 1nm are
-!--    explained in article of Kulmala et al. (2001). The particles of diameter
-!--    zdcrit ~1.14 nm  and reglim = 3nm are both in turn the "number 1" 
-!--    variables (Kulmala et al. 2001).             
+          zgamma = 0.23_wp * ( zdcrit * 1.0E+9_wp )**0.2_wp * ( zdmean / 150.0_wp )**0.048_wp *    &
+                   ( ptemp / 293.0_wp )**( -0.75_wp ) * ( arhoh2so4 / 1000.0_wp )**( -0.33_wp )
+!
+!--       Factor eta (nm, Eq. 11)
+          zeta = MIN( zgamma * zcsink / z_gr_clust, zdcrit * 1.0E11_wp )
+       ENDIF
+!
+!--    Number conc. of clusters surviving to 3 nm in a time step (#/m3, Eq.14)
+       zj3 = zjnuc * EXP( MIN( 0.0_wp, zeta / 3.0_wp - zeta / ( zdcrit * 1.0E9_wp ) ) )
+
+    ELSEIF ( nj3 > 1 )  THEN   ! Lehtinen et al. (2007) or Anttila et al. (2010)
+!
+!--    Defining the parameter m (zm_para) for calculating the coagulation sink onto background
+!--    particles (Eq. 5&6 in Lehtinen et al. 2007). The growth is investigated between 
+!--    [d1,reglim(1)] = [zdcrit,3nm] and m = LOG( CoagS_dx / CoagX_zdcrit ) / LOG( reglim / zdcrit )
+!--    (Lehtinen et al. 2007, Eq. 6).
+!--    The steps for the coagulation sink for reglim = 3nm and zdcrit ~= 1nm are explained in 
+!--    Kulmala et al. (2001). The particles of diameter zdcrit ~1.14 nm  and reglim = 3nm are both 
+!--    in turn the "number 1" variables (Kulmala et al. 2001).
 !--    c = critical (1nm), x = 3nm, 2 = wet or mean droplet
-!--    Sum of the radii, R12 = R1 + zR2 (m) of two particles 1 and 2
-       zRc2 = zdcrit / 2.0_wp + paero(:)%dwet / 2.0_wp
-       zRx2 = reglim(1) / 2.0_wp + paero(:)%dwet / 2.0_wp
-!       
-!--    The mass of particle (kg) (comes only from H2SO4)
-       zm_c = 4.0_wp / 3.0_wp * pi * ( zdcrit / 2.0_wp ) ** 3.0_wp * arhoh2so4                     
-       zm_x = 4.0_wp / 3.0_wp * pi * ( reglim(1) / 2.0_wp ) ** 3.0_wp *        &
-              arhoh2so4                  
-       zm_2 = 4.0_wp / 3.0_wp * pi * ( paero(:)%dwet / 2.0_wp )** 3.0_wp *     &
-              arhoh2so4
-!              
+!
+!--    Sum of the radii, R12 = R1 + R2 (m) of two particles 1 and 2
+       z_r_c2 = zdcrit / 2.0_wp + paero(:)%dwet / 2.0_wp
+       z_r_x2 = reglim(1) / 2.0_wp + paero(:)%dwet / 2.0_wp
+!
+!--    Particle mass (kg) (comes only from H2SO4)
+       zm_c = 4.0_wp / 3.0_wp * pi * ( zdcrit / 2.0_wp )**3 * arhoh2so4
+       zm_x = 4.0_wp / 3.0_wp * pi * ( reglim(1) / 2.0_wp )**3 * arhoh2so4
+       zm_2 = 4.0_wp / 3.0_wp * pi * ( 0.5_wp * paero(:)%dwet )**3 * arhoh2so4
+!
 !--    Mean relative thermal velocity between the particles (m/s)
        zcv_c = SQRT( 8.0_wp * abo * ptemp / ( pi * zm_c ) )
        zcv_x = SQRT( 8.0_wp * abo * ptemp / ( pi * zm_x ) )
        zcv_2 = SQRT( 8.0_wp * abo * ptemp / ( pi * zm_2 ) )
-!       
-!--    Average velocity after coagulation               
-       zcv_c2 = SQRT( zcv_c ** 2.0_wp + zcv_2 ** 2.0_wp )
-       zcv_x2 = SQRT( zcv_x ** 2.0_wp + zcv_2 ** 2.0_wp )
-!       
+!
+!--    Average velocity after coagulation
+       zcv_c2(:) = SQRT( zcv_c**2 + zcv_2**2 )
+       zcv_x2(:) = SQRT( zcv_x**2 + zcv_2**2 )
+!
 !--    Knudsen number (zmfp = mean free path of condensing vapour)
        zknud_c = 2.0_wp * zmfp / zdcrit
        zknud_x = 2.0_wp * zmfp / reglim(1)
-       zknud_2 = MAX( 0.0_wp, 2.0_wp * zmfp / paero(:)%dwet )
-!
-!--    Cunningham correction factor                
-       zCc_c = 1.0_wp + zknud_c * ( 1.142_wp + 0.558_wp *                      &
-               EXP( -0.999_wp / zknud_c ) ) 
-       zCc_x = 1.0_wp + zknud_x * ( 1.142_wp + 0.558_wp *                      &
-               EXP( -0.999_wp / zknud_x ) )
-       zCc_2 = 1.0_wp + zknud_2 * ( 1.142_wp + 0.558_wp *                      &
-               EXP( -0.999_wp / zknud_2 ) )
-!                      
-!--    Gas dynamic viscosity (N*s/m2). 
-!--    Viscocity(air @20C) = 1.81e-5_dp N/m2 *s (Hinds, p. 25)                      
-       zmyy = 1.81E-5_wp * ( ptemp / 293.0_wp) ** ( 0.74_wp ) 
-!       
-!--    Particle diffusion coefficient (m2/s)                
-       zDc_c = abo * ptemp * zCc_c / ( 3.0_wp * pi * zmyy * zdcrit )  
-       zDc_x = abo * ptemp * zCc_x / ( 3.0_wp * pi * zmyy * reglim(1) )
-       zDc_2 = abo * ptemp * zCc_2 / ( 3.0_wp * pi * zmyy * paero(:)%dwet )
-!       
+       zknud_2(:) = MAX( 0.0_wp, 2.0_wp * zmfp / paero(:)%dwet )
+!
+!--    Cunningham correction factors (Allen and Raabe, 1985)
+       zcc_c    = 1.0_wp + zknud_c    * ( 1.142_wp + 0.558_wp * EXP( -0.999_wp / zknud_c ) )
+       zcc_x    = 1.0_wp + zknud_x    * ( 1.142_wp + 0.558_wp * EXP( -0.999_wp / zknud_x ) )
+       zcc_2(:) = 1.0_wp + zknud_2(:) * ( 1.142_wp + 0.558_wp * EXP( -0.999_wp / zknud_2(:) ) )
+!
+!--    Gas dynamic viscosity (N*s/m2). Here, viscocity(air @20C) = 1.81e-5_dp N/m2 *s (Hinds, p. 25)
+       zmyy = 1.81E-5_wp * ( ptemp / 293.0_wp )**0.74_wp
+!
+!--    Particle diffusion coefficient (m2/s) (continuum regime)
+       zdc_c(:) = abo * ptemp * zcc_c    / ( 3.0_wp * pi * zmyy * zdcrit )
+       zdc_x(:) = abo * ptemp * zcc_x    / ( 3.0_wp * pi * zmyy * reglim(1) )
+       zdc_2(:) = abo * ptemp * zcc_2(:) / ( 3.0_wp * pi * zmyy * paero(:)%dwet )
+!
 !--    D12 = D1+D2 (Seinfield and Pandis, 2nd ed. Eq. 13.38)
-       zDc_c2 = zDc_c + zDc_2   
-       zDc_x2 = zDc_x + zDc_2 
-!       
-!--    zgammaF = 8*D/pi/zcv (m) for calculating zomega
-       zgammaF_c = 8.0_wp * zDc_c / pi / zcv_c 
-       zgammaF_x = 8.0_wp * zDc_x / pi / zcv_x
-       zgammaF_2 = 8.0_wp * zDc_2 / pi / zcv_2
-!       
-!--    zomega (m) for calculating zsigma              
-       zomega_c = ( ( zRc2 + zgammaF_c ) ** 3 - ( zRc2 ** 2 +                  &
-                      zgammaF_c ) ** ( 3.0_wp / 2.0_wp ) ) / ( 3.0_wp *        &
-                      zRc2 * zgammaF_c ) - zRc2  
-       zomega_x = ( ( zRx2 + zgammaF_x ) ** 3.0_wp - ( zRx2 ** 2.0_wp +        &
-                      zgammaF_x ) ** ( 3.0_wp / 2.0_wp ) ) / ( 3.0_wp *        &
-                      zRx2 * zgammaF_x ) - zRx2
-       zomega_2c = ( ( zRc2 + zgammaF_2 ) ** 3.0_wp - ( zRc2 ** 2.0_wp +       &
-                       zgammaF_2 ) ** ( 3.0_wp / 2.0_wp ) ) / ( 3.0_wp *       &
-                       zRc2 * zgammaF_2 ) - zRc2 
-       zomega_2x = ( ( zRx2 + zgammaF_2 ) ** 3.0_wp - ( zRx2 ** 2.0_wp +       &
-                       zgammaF_2 ) ** ( 3.0_wp / 2.0_wp ) ) / ( 3.0_wp *       &
-                       zRx2 * zgammaF_2 ) - zRx2 
-!                       
-!--    The distance (m) at which the two fluxes are matched (condensation and
-!--    coagulation sinks?)           
-       zsigma_c2 = SQRT( zomega_c ** 2.0_wp + zomega_2c ** 2.0_wp ) 
-       zsigma_x2 = SQRT( zomega_x ** 2.0_wp + zomega_2x ** 2.0_wp ) 
-!       
-!--    Coagulation coefficient in the continuum regime (m*m2/s)
-       zK_c2 = 4.0_wp * pi * zRc2 * zDc_c2 / ( zRc2 / ( zRc2 + zsigma_c2 ) +   &
-               4.0_wp * zDc_c2 / ( zcv_c2 * zRc2 ) ) 
-       zK_x2 = 4.0_wp * pi * zRx2 * zDc_x2 / ( zRx2 / ( zRx2 + zsigma_x2 ) +   &
-               4.0_wp * zDc_x2 / ( zcv_x2 * zRx2 ) )
-!               
-!--    Coagulation sink (1/s)
-       zCoagS_c = MAX( 1.0E-20_wp, SUM( zK_c2 * paero(:)%numc ) )          
-       zCoagS_x = MAX( 1.0E-20_wp, SUM( zK_x2 * paero(:)%numc ) ) 
-!       
-!--    Parameter m for calculating the coagulation sink onto background 
-!--    particles (Eq. 5&6 in Lehtinen et al. 2007)             
-       zm_para = LOG( zCoagS_x / zCoagS_c ) / LOG( reglim(1) / zdcrit )
-!       
+       zdc_c2 = zdc_c + zdc_2
+       zdc_x2 = zdc_x + zdc_2
+!
+!--    zgamma_f = 8*D/pi/zcv (m) for calculating zomega (Fuchs, 1964)
+       zgamma_f_c = 8.0_wp * zdc_c / pi / zcv_c
+       zgamma_f_x = 8.0_wp * zdc_x / pi / zcv_x
+       zgamma_f_2 = 8.0_wp * zdc_2 / pi / zcv_2
+!
+!--    zomega (m) for calculating zsigma
+       zomega_c = ( ( z_r_c2 + zgamma_f_c )**3 - ( z_r_c2 ** 2 + zgamma_f_c )**1.5_wp ) /          &
+                  ( 3.0_wp * z_r_c2 * zgamma_f_c ) - z_r_c2
+       zomega_x = ( ( z_r_x2 + zgamma_f_x )**3 - ( z_r_x2**2 + zgamma_f_x )** 1.5_wp ) /           &
+                  ( 3.0_wp * z_r_x2 * zgamma_f_x ) - z_r_x2
+       zomega_2c = ( ( z_r_c2 + zgamma_f_2 )**3 - ( z_r_c2**2 + zgamma_f_2 )**1.5_wp ) /           &
+                   ( 3.0_wp * z_r_c2 * zgamma_f_2 ) - z_r_c2
+       zomega_2x = ( ( z_r_x2 + zgamma_f_2 )**3 - ( z_r_x2**2 + zgamma_f_2 )**1.5_wp ) /           &
+                   ( 3.0_wp * z_r_x2 * zgamma_f_2 ) - z_r_x2 
+!
+!--    The distance (m) at which the two fluxes are matched (condensation and coagulation sinks)
+       zsigma_c2 = SQRT( zomega_c**2 + zomega_2c**2 )
+       zsigma_x2 = SQRT( zomega_x**2 + zomega_2x**2 )
+!
+!--    Coagulation coefficient in the continuum regime (m*m2/s, Eq. 17 in Kulmala et al., 2001)
+       z_k_c2 = 4.0_wp * pi * z_r_c2 * zdc_c2 / ( z_r_c2 / ( z_r_c2 + zsigma_c2 ) +                &
+               4.0_wp * zdc_c2 / ( zcv_c2 * z_r_c2 ) )
+       z_k_x2 = 4.0_wp * pi * z_r_x2 * zdc_x2 / ( z_r_x2 / ( z_r_x2 + zsigma_x2 ) +                &
+               4.0_wp * zdc_x2 / ( zcv_x2 * z_r_x2 ) )
+!
+!--    Coagulation sink (1/s, Eq. 16 in Kulmala et al., 2001)
+       zcoags_c = MAX( 1.0E-20_wp, SUM( z_k_c2 * paero(:)%numc ) )
+       zcoags_x = MAX( 1.0E-20_wp, SUM( z_k_x2 * paero(:)%numc ) )
+!
+!--    Parameter m for calculating the coagulation sink onto background particles (Eq. 5&6 in 
+!--    Lehtinen et al. 2007)
+       zm_para = LOG( zcoags_x / zcoags_c ) / LOG( reglim(1) / zdcrit )
+!
 !--    Parameter gamma for calculating the formation rate J of particles having
-!--    a diameter zdcrit < d < reglim(1) (Anttila et al. 2010, eq. 5)
-       zgamma = ( ( ( reglim(1) / zdcrit ) ** ( zm_para + 1.0_wp ) ) - 1.0_wp )&
-                / ( zm_para + 1.0_wp )     
-                
-       IF ( nj3 == 2 )  THEN   ! Coagulation sink
-!       
-!--       Formation rate J before iteration (#/m3s)                
-          zj3 = zjnuc * EXP( MIN( 0.0_wp, -zgamma * zdcrit * zCoagS_c /        &
-                ( zGRclust * 1.0E-9_wp / ( 60.0_wp ** 2.0_wp ) ) ) )
-                
-       ELSEIF ( nj3 == 3 )  THEN  ! Coagulation sink and self-coag.
-!--       IF polluted air... then the self-coagulation becomes important. 
-!--       Self-coagulation of small particles < 3 nm.
-!
-!--       "Effective" coagulation coefficient between freshly-nucleated 
-!--       particles:
-          zKeff = 5.0E-16_wp   ! cm3/s
-!          
-!--       zlambda parameter for "adjusting" the growth rate due to the 
-!--       self-coagulation
-          zlambda = 6.0_wp 
+!--    a diameter zdcrit < d < reglim(1) (Anttila et al. 2010, eq. 5 or Lehtinen et al.,2007, eq. 7)
+       zgamma = ( ( ( reglim(1) / zdcrit )**( zm_para + 1.0_wp ) ) - 1.0_wp ) / ( zm_para + 1.0_wp )
+
+       IF ( nj3 == 2 )  THEN   ! Lehtinen et al. (2007): coagulation sink
+!
+!--       Formation rate J before iteration (#/m3s)
+          zj3 = zjnuc * EXP( MIN( 0.0_wp, -zgamma * zdcrit * zcoags_c / ( z_gr_clust * 1.0E-9_wp / &
+                60.0_wp**2 ) ) )
+
+       ELSEIF ( nj3 == 3 )  THEN  ! Anttila et al. (2010): coagulation sink and self-coag.
+!
+!--       If air is polluted, the self-coagulation becomes important. Self-coagulation of small 
+!--       particles < 3 nm.
+!
+!--       "Effective" coagulation coefficient between freshly-nucleated particles:
+          z_k_eff = 5.0E-16_wp   ! m3/s
+!
+!--       zlambda parameter for "adjusting" the growth rate due to the self-coagulation
+          zlambda = 6.0_wp
+
           IF ( reglim(1) >= 10.0E-9_wp )  THEN   ! for particles >10 nm:
-             zKeff   = 5.0E-17_wp
+             z_k_eff   = 5.0E-17_wp
              zlambda = 3.0_wp
           ENDIF
-!          
+!
 !--       Initial values for coagulation sink and growth rate  (m/s)
-          zCoagStot = zCoagS_c
-          zGRtot = zGRclust * 1.0E-9_wp / 60.0_wp ** 2.0_wp 
-!          
+          zcoagstot = zcoags_c
+          z_gr_tot = z_gr_clust * 1.0E-9_wp / 60.0_wp**2
+!
 !--       Number of clusters/particles at the size range [d1,dx] (#/m3):
-          zNnuc = zjnuc / zCoagStot !< Initial guess 
-!          
+          z_n_nuc = zjnuc / zcoagstot !< Initial guess
+!
 !--       Coagulation sink and growth rate due to self-coagulation:
           DO  iteration = 1, 5
-             zCoagStot = zCoagS_c + zKeff * zNnuc * 1.0E-6_wp   ! (1/s)  
-             zGRtot = zGRclust * 1.0E-9_wp / ( 3600.0_wp ) +  1.5708E-6_wp *   &
-                      zlambda * zdcrit ** 3.0_wp * ( zNnuc * 1.0E-6_wp ) *     &
-                      zcv_c * avo * 1.0E-9_wp / 3600.0_wp 
-             zeta = - zCoagStot / ( ( zm_para + 1.0_wp ) * zGRtot * ( zdcrit **&
-                      zm_para ) )   ! Eq. 7b (Anttila) 
-             zNnuc =  zNnuc_tayl( zdcrit, reglim(1), zm_para, zjnuc, zeta,     &
-                      zGRtot )
+             zcoagstot = zcoags_c + z_k_eff * z_n_nuc * 1.0E-6_wp   ! (1/s, Anttila et al., eq. 1)
+             z_gr_tot = z_gr_clust * 2.77777777E-7_wp +  1.5708E-6_wp * zlambda * zdcrit**3 *      &
+                      ( z_n_nuc * 1.0E-6_wp ) * zcv_c * avo * 2.77777777E-7_wp ! (Eq. 3)
+             zeta = - zcoagstot / ( ( zm_para + 1.0_wp ) * z_gr_tot * ( zdcrit**zm_para ) ) ! (Eq. 7b)
+!
+!--          Calculate Eq. 7a (Taylor series for the number of particles between [d1,dx])
+             z_n_nuc =  z_n_nuc_tayl( zdcrit, reglim(1), zm_para, zjnuc, zeta, z_gr_tot )
           ENDDO
-!          
-!--       Calculate the final values with new zNnuc:	
-          zCoagStot = zCoagS_c + zKeff * zNnuc * 1.0E-6_wp   ! (1/s) 
-          zGRtot = zGRclust * 1.0E-9_wp / 3600.0_wp + 1.5708E-6_wp *  zlambda  &
-                   * zdcrit ** 3.0_wp * ( zNnuc * 1.0E-6_wp ) * zcv_c * avo *  &
-                   1.0E-9_wp / 3600.0_wp !< (m/s)
-          zj3 = zjnuc * EXP( MIN( 0.0_wp, -zgamma * zdcrit * zCoagStot /       &
-                zGRtot ) )   ! (Eq. 5a) (#/m3s)
-                
-       ENDIF
-       
+!
+!--       Calculate the final values with new z_n_nuc:
+          zcoagstot = zcoags_c + z_k_eff * z_n_nuc * 1.0E-6_wp   ! (1/s)
+          z_gr_tot = z_gr_clust * 1.0E-9_wp / 3600.0_wp + 1.5708E-6_wp *  zlambda * zdcrit**3 *    &
+                   ( z_n_nuc * 1.0E-6_wp ) * zcv_c * avo * 1.0E-9_wp / 3600.0_wp !< (m/s)
+          zj3 = zjnuc * EXP( MIN( 0.0_wp, -zgamma * zdcrit * zcoagstot / z_gr_tot ) ) ! (#/m3s, Eq. 5a)
+
+       ENDIF
     ENDIF
-!-- If J3 very small (< 1 #/cm3), neglect particle formation. In real atmosphere
-!-- this would mean that clusters form but coagulate to pre-existing particles 
-!-- who gain sulphate. Since CoagS ~ CS (4piD*CS'), we do *not* update H2SO4 
-!-- concentration here but let condensation take care of it.
-!-- Formation mass rate of molecules (molec/m3s) for 1: H2SO4 and 2: organic 
-!-- vapour
+!
+!-- If J3 very small (< 1 #/cm3), neglect particle formation. In real atmosphere this would mean
+!-- that clusters form but coagulate to pre-existing particles who gain sulphate. Since 
+!-- CoagS ~ CS (4piD*CS'), we do *not* update H2SO4 concentration here but let condensation take 
+!-- care of it. Formation mass rate of molecules (molec/m3s) for 1: H2SO4 and 2: organic vapour
     pj3n3(1) = zj3 * n3 * pxsa
     pj3n3(2) = zj3 * n3 * pxocnv
-                                  
-                         
+
  END SUBROUTINE nucleation
 
